#define STREAM_BUFFER_READ_SIZE  16384
#define STREAM_BUFFER_WRITE_SIZE 1024

typedef struct BufferedReader_ {
   int fd;
   char *buf;
   char *buf_pnt;
   char *buf_end;   
} BufferedReader;

typedef struct BufferedWriter_ {
   int fd;
   char *buf;
   char *buf_pnt;
   size_t space_left;
} BufferedWriter;

#define buffered_reader_readchar(br, where) \
   ((br)->buf_pnt == NULL) ? (ssize_t) 0 : \
     ( \
       ((br)->buf_pnt != (br)->buf_end) ? \
          (  (*(unsigned char *) (where) = *((br)->buf_pnt++)), (ssize_t) 1U  ) : \
          buffered_reader_read((br), (where), (size_t) 1U) \
     ) 

int buffered_reader_init(BufferedReader * const br, int fd);
ssize_t buffered_reader_read(BufferedReader * const br,
			     void *where_, size_t size);
int buffered_reader_get_line(BufferedReader * const br,
			     char *buf, size_t size);
int buffered_reader_close(BufferedReader * const br, int really);

int buffered_writer_init(BufferedWriter * const bw, int fd);
int buffered_writer_write(BufferedWriter * const bw,
			  const void * const where_, size_t size);
int buffered_writer_flush(BufferedWriter * const bw);
int buffered_writer_close(BufferedWriter * const bw, int really);

