#include <stdlib.h>
#include <unistd.h>
#include <stdio.h>
#include <sys/types.h>
#include <sys/ipc.h>
#include <sys/sem.h>
#include <sys/shm.h>
#include <pthread.h>

#define DELIVERIES 42
typedef struct ShmQueue_ {
   pid_t pid;
   key_t key;
   int semid;
} ShmQueue;

ShmQueue *shmadr;
struct sembuf sb;
int sems;
pthread_t clients[DELIVERIES];

void *client_thread(void *shmadrpnt_)
{
   int z;
   ShmQueue *shmadrpnt = (ShmQueue *) shmadrpnt_;
   struct sembuf sb;   

   sleep(2);
   if (shmadrpnt == NULL) {
      puts("BUG in client_thread initial assertions");
      return NULL;
   }
   z = DELIVERIES - (shmadrpnt - shmadr) / (sizeof *shmadr);
   if (z < 0 || z > DELIVERIES) {
      puts("BUG in client_thread z calculation");
      return NULL;
   }
   puts("syncing");
   sb.sem_num = 0;
   sb.sem_flg = 0;	 
   sb.sem_op = 1;
   if (semop(shmadrpnt->semid, &sb, 1) < 0) {
      perror("client_thread semop wait");
   }   
   puts("Client thread is waiting for data");
   sb.sem_num = 1;
   sb.sem_flg = 0;	 
   sb.sem_op = -1;   
   if (semop(shmadrpnt->semid, &sb, 1) < 0) {
      perror("client_thread semop wait");
   }
   puts("Client thread is now happy");
   
   return NULL;
}

void new_request()
{
   static char busy = 0;
   int z;
   ShmQueue *shmadrpnt = shmadr;
   
   if (busy != 0) {
      return;
   }
   busy++;
   puts("New request !");
   z = DELIVERIES;
   do {
      if (shmadrpnt->pid >= (pid_t) 0 && shmadrpnt->key == (key_t) 0) {
	 printf("Une requete trouve en %d, pid=%d\n", z, (int) shmadrpnt->pid);
	 shmadrpnt->key = (key_t) 17;
	 
	  {
	     key_t zz = 0x43a0 + z;	     	     
	     if ((shmadrpnt->semid = semget(zz, 2, IPC_CREAT | 0600)) < 0) {
		perror("semget semid");
	     }	     
	     semctl(shmadrpnt->semid, 0, SETVAL, 0);	    
	     semctl(shmadrpnt->semid, 1, SETVAL, 0);	    	     
	  }	 
	 
	 if (semctl(sems, z - 1, GETVAL, 0) != 0) {
	    printf("sems.getval = %d\n",
		   (int) semctl(sems, z - 1, GETVAL, 0));
	    perror("sems.getval != 0");
	    semctl(sems, z - 1, SETVAL, -1);	    
	 }
	 sb.sem_num = z - 1;
	 sb.sem_flg = 0;	 
	 sb.sem_op = 1;
	 if (semop(sems, &sb, 1) < 0) {
	    perror("semop increase");
	 }
	 printf("after increase : sems.getval = %d\n",
		(int) semctl(sems, z - 1, GETVAL, 0));
	 /* Should be detached */
	 if (pthread_create(&clients[z - 1], NULL, client_thread, shmadrpnt) != 0) {
	    perror("pthread_create");
	 }
      }
      shmadrpnt++;
      z--;
   } while (z != 0);
   
   busy = 0;
}

int main(void)
{
   int shm;
   int wakeup;
   
   if ((shm = shmget((key_t) 0x4245, DELIVERIES * sizeof *shmadr, IPC_CREAT | 0600)) < 0) {
      perror("shmget");
      return 1;
   }
   if ((shmadr = (ShmQueue *) shmat(shm, NULL, 0)) == NULL) {
      perror("shmat");
      return 1;
   }
   if ((wakeup = semget((key_t) 0x4249, 1, IPC_CREAT | 0600)) < 0) {
      perror("semget");
      return 1;
   }   
   if ((sems = semget((key_t) 0x4247, DELIVERIES, IPC_CREAT | 0600)) < 0) {
      perror("semget");
      return 1;
   }
     {
	int z = DELIVERIES;
	
	do {
	   z--;
	   semctl(sems, z, SETVAL, 0);
	} while (z != 0);
     }
     {
	ShmQueue *shmadrpnt = shmadr;
	int z = DELIVERIES;
	
	do {
	   shmadrpnt->pid = (pid_t) -1;
	   shmadrpnt++;
	   z--;
	} while (z != 0);
     }
   for (;;) {
      puts("Waiting...");
      sb.sem_num = 0;
      sb.sem_flg = 0;	 
      sb.sem_op = -1;
      if (semop(wakeup, &sb, 1) < 0) {
	 perror("semop wait");
      }
      new_request();
   }

   shmdt((char *) shmadr);
   
   return 0;
}
