#include <stdlib.h>
#include <unistd.h>
#include <stdio.h>
#include <sys/types.h>
#include <sys/ipc.h>
#include <sys/sem.h>
#include <sys/shm.h>

#define DELIVERIES 42
typedef struct ShmQueue_ {
   pid_t pid;
   key_t key;
   int semid;
} ShmQueue;

int main(void)
{
   int shm;
   int sems;
   int wakeup;
   int memlock;
   struct sembuf sb;   
   ShmQueue *shmadr;
   
   sb.sem_flg = 0;
   if ((shm = shmget((key_t) 0x4245, 0U, 0600)) < 0) {
      perror("shmget");
      return 1;
   }
   if ((shmadr = (ShmQueue *) shmat(shm, NULL, 0)) == NULL) {
      perror("shmat");
      return 1;
   }
   if ((sems = semget((key_t) 0x4247, DELIVERIES, 0600)) < 0) {
      perror("semget");
      return 1;
   }
   if ((wakeup = semget((key_t) 0x4249, 1, 0600)) < 0) {
      perror("semget");
      return 1;
   }   
   if ((memlock = semget((key_t) 0x424a, 1, IPC_CREAT | 0600)) < 0) {
      perror("semget");
      return 1;
   }   
   
     {
	ShmQueue *shmadrpnt = shmadr;
	int z = DELIVERIES;
	
	sb.sem_flg = 0;
	sb.sem_num = 0;
	sb.sem_op = 0;
	if (semop(memlock, &sb, 1) < 0) {
	   perror("semop memlock");
	}
	sb.sem_op = 1;
	if (semop(memlock, &sb, 1) < 0) {
	   perror("semop memlock");
	}
	for (;;) {
	   if (shmadrpnt->pid < 0) {
	      break;
	   }
	   shmadrpnt++;
	   z--;
	   if (z == 0) {
	      puts("BUG ?!");
	      sb.sem_flg = 0;
	      sb.sem_num = 0;
	      sb.sem_op = -1;
	      if (semop(memlock, &sb, 1) < 0) {
		 perror("semop memlock");
	      }		      
	      return 1;
	   }	   
	}
	sb.sem_flg = 0;
	sb.sem_num = 0;
	sb.sem_op = -1;
	if (semop(memlock, &sb, 1) < 0) {
	   perror("semop memlock");
	}	
	printf("Emplacement trouv en %d !\n", z);
	while (shmadrpnt->pid >= (pid_t) 0 && shmadrpnt->key != (key_t) 0);
	shmadrpnt->key = (key_t) 0;
	shmadrpnt->semid = 0;	
	shmadrpnt->pid = getpid();
	sb.sem_flg = IPC_NOWAIT;
	sb.sem_num = z - 1;
	sb.sem_op = 0;
	printf("sems.getval de %d = %d\n", z,
	       (int) semctl(sems, z - 1, GETVAL, 0));	
	if (semop(sems, &sb, 1) < 0) {
	   puts("On a pris de l'avance : rponse reue avant l'envoi du signal");
	}
	printf("z = %d\n", z);
	printf("before set sems.getval = %d\n", 
	       (int) semctl(sems, z - 1, GETVAL, 0));	
	puts("Envoi du signal");
	sb.sem_flg = 0;	
	sb.sem_num = 0;
	sb.sem_op = 1;
	if (semop(wakeup, &sb, 1) < 0) {
	   perror("semop wakeup");
	}
	sb.sem_num = z - 1;	
	sb.sem_op = 0;
	sb.sem_op = -1;
	if (semop(sems, &sb, 1) < 0) {
	   perror("semop wait");
	}
	printf("after wait sems.getval = %d\n", 
	       (int) semctl(sems, z - 1, GETVAL, 0));
	if (shmadrpnt->pid != getpid()) {
	   puts("pid change ?!");
	   return 1;
	}
	printf("Retour : [%d]\n", (int) shmadrpnt->key);
		
	/* Here we send some data */
	
	puts("Syncing data");
	sb.sem_num = 0;
	sb.sem_op = 0;
	sb.sem_op = -1;
	if (semop(shmadrpnt->semid, &sb, 1) < 0) {
	   perror("semop data send");
	}	
	puts("Sending data");
	sb.sem_num = 1;
	sb.sem_op = 0;
	sb.sem_op = 1;
	if (semop(shmadrpnt->semid, &sb, 1) < 0) {
	   perror("semop data send");
	}
	
	puts("Data sent, unlocking memory");
	
	/* Unlock memory */	
	
	sb.sem_flg = 0;
	sb.sem_num = 0;
	sb.sem_op = 0;
	if (semop(memlock, &sb, 1) < 0) {
	   perror("semop memlock");
	}
	sb.sem_op = 1;
	if (semop(memlock, &sb, 1) < 0) {
	   perror("semop memlock");
	}	
	shmadrpnt->pid = (pid_t) -1;
	sb.sem_op = -1;
	if (semop(memlock, &sb, 1) < 0) {
	   perror("semop memlock");
	}		
	puts("Yeeaaaehhh");
     }
   shmdt((char *) shmadr);
   
   return 0;
}
