#include <stdlib.h>
#include <unistd.h>
#include <stdio.h>
#include <sys/types.h>
#include <sys/ipc.h>
#include <sys/shm.h>
#include <sys/msg.h>

#define CHUNK_MSG_SIZE 16384
#define CHUNK_HEADER_SIZE sizeof(size_t)
#define CHUNK_SIZE (CHUNK_MSG_SIZE + CHUNK_HEADER_SIZE)
#define MSGLEN 32
#define MSG_NEWCNX "newcnx"
#define MSG_ACK_NEWCNX "ack_newcnx"
#define MSG_DATA "data"
#define MSG_ACK_DATA "ack_data"
#define MSG_EOF_DATA "EOF_data"
#define MSG_ACK_EOF_DATA "ack_EOF_data"
#define MSG_ABORT "abort"

int main(void)
{
   int msqids, msqidr, msqids2, msqidr2;
   struct msgbuf *msgps, *msgpr, *msgps2, *msgpr2;
   int datashmid;
   int fromtoshmid;
   
   if ((msqids = msgget((key_t) 0x4242, 0600)) < 0) {
      perror("msgget");
      return 1;
   }
   if ((msqidr = msgget((key_t) 0x4243, 0600)) < 0) {
      perror("msgget");
      return 1;
   }
   if ((msqids2 = msgget((key_t) 0x4244, 0600)) < 0) {
      perror("msgget");
      return 1;
   }
   if ((msqidr2 = msgget((key_t) 0x4245, 0600)) < 0) {
      perror("msgget");
      return 1;
   }
   if ((msgps = malloc(sizeof *msgps + MSGLEN)) == NULL) {
      perror("malloc");
      return 1;
   }
   if ((msgpr = malloc(sizeof *msgpr + MSGLEN)) == NULL) {
      perror("malloc");
      return 1;
   }
   if ((msgps2 = malloc(sizeof *msgps2 + MSGLEN)) == NULL) {
      perror("malloc");
      return 1;
   }
   if ((msgpr2 = malloc(sizeof *msgpr2 + MSGLEN)) == NULL) {
      perror("malloc");
      return 1;
   }
   if ((fromtoshmid = shmget(IPC_PRIVATE, CHUNK_SIZE, IPC_CREAT | 0600)) < 0) {
      perror("shmget");
   }
   msgps->mtype = (long) getpid();   
   snprintf(msgps->mtext, MSGLEN, MSG_NEWCNX "%d", fromtoshmid);
   msgps->mtext[MSGLEN - 1] = 0;   
   puts("Envoi de " MSG_NEWCNX);
   if (msgsnd(msqids, msgps, MSGLEN, 0) < 0) {
      perror("msgsnd");
   }
   puts("Envoy");
   puts("Attente de l'acquitement");
   if (msgrcv(msqidr, msgpr, MSGLEN, (long) getpid(), 0) < 0) {
      perror("msgrcv");
   }
   printf("Reu : [%s]\n", msgps->mtext);
   if (strncmp(msgps->mtext, MSG_ABORT, sizeof MSG_ABORT - 1) == 0) {
      puts("Abandon");
      return EXIT_FAILURE;
   }
   shmctl(fromtoshmid, IPC_RMID, NULL);      
   if ((datashmid = shmget(IPC_PRIVATE, CHUNK_SIZE, IPC_CREAT | 0600)) < 0) {
      perror("shmget");
   }   
   msgps2->mtype = (long) getpid();
   snprintf(msgps2->mtext, MSGLEN, MSG_DATA "%d", datashmid);
   msgps2->mtext[MSGLEN - 1] = 0;   
   puts("Envoi des donnes et de " MSG_DATA);
   if (msgsnd(msqids2, msgps2, MSGLEN, 0) < 0) {
      perror("msgsnd");
   }
   puts("Envoy");
   puts("Attente de l'acquitement");
   if (msgrcv(msqidr2, msgpr2, MSGLEN, (long) getpid(), 0) < 0) {
      perror("msgrcv");
   }   
   printf("Reu : [%s]\n", msgpr2->mtext);
   if (strncmp(msgpr2->mtext, MSG_ABORT, sizeof MSG_ABORT - 1) == 0) {
      puts("Abandon");
      return EXIT_FAILURE;
   }
   msgps2->mtype = (long) getpid();   
   snprintf(msgps2->mtext, MSGLEN, MSG_EOF_DATA "%d", datashmid);
   msgps2->mtext[MSGLEN - 1] = 0;   
   puts("Envoi des donnes de fin et de " MSG_EOF_DATA);
   if (msgsnd(msqids2, msgps2, MSGLEN, 0) < 0) {
      perror("msgsnd");
   }
   puts("Envoy");
   puts("Attente de l'acquitement final");
   if (msgrcv(msqidr2, msgpr2, MSGLEN, (long) getpid(), 0) < 0) {
      perror("msgrcv");
   }
   printf("Reu : [%s]\n", msgpr2->mtext);
   if (strncmp(msgps->mtext, MSG_ABORT, sizeof MSG_ABORT - 1) == 0) {
      puts("Abandon");
      return EXIT_FAILURE;
   }
   shmctl(datashmid, IPC_RMID, NULL);   
      
   free(msgps);
   free(msgpr);
   free(msgps2);
   free(msgpr2);
   
   return 0;
}
