/* Simple but efficient memory leaks finder */
/* (C)opyleft 2000 Frank DENIS aka Jedi/Sector One <j@4u.net> */

#ifndef __LEAKFINDER_H__
# define __LEAKFINDER_H__
# ifdef USE_LEAKFINDER
#  undef malloc
#  define malloc(X) lf_malloc(X, __FILE__, __PRETTY_FUNCTION__, __LINE__)
#  undef realloc
#  define realloc(X, Y) lf_realloc(X, Y, __FILE__, __PRETTY_FUNCTION__, __LINE__)
#  undef calloc
#  define calloc(X, Y) lf_calloc(X, Y, __FILE__, __PRETTY_FUNCTION__, __LINE__)
#  undef free
#  define free(X) lf_free(X, __FILE__, __PRETTY_FUNCTION__, __LINE__)
#  undef strdup
#  define strdup(X) lf_strdup(X, __FILE__, __PRETTY_FUNCTION__, __LINE__)

void *lf_malloc(size_t size, 
		const char *file, const char *fun, int line);

void *lf_realloc(void *buf, size_t size, 
		 const char *file, const char *fun, int line);

void *lf_calloc(size_t nmemb, size_t size, 
		const char *file, const char *fun, int line);

void lf_free(void *buf,
	     const char *file, const char *fun, int line);

char *lf_strdup(const char *buf,
		const char *file, const char *fun, int line);

# endif
#endif
