#include <stdlib.h>
#include <stdio.h>
#include <string.h>
#include <ctype.h>
#include "lmail.h"
#include "strtools.h"

/* unsafe unsigned long to string conversion. Returns the missing final \0 */

char *unsafe_ultostr(char *target, unsigned long value)
{
   char buf[42];
   size_t z = 0U;

   do {
      buf[z++] = "0123456789"[value % 10U];
      value /= 10U;
   } while (value > 0U);
   do {
      *target++ = buf[--z];
   } while (z > 0U);
   
   return target;
}

/* check if the end of s1 is s2 */

int strcmp_reverse(const char * const s1, const size_t s1_length,
		   const char * const s2)
{
   size_t s2_length;   
   
   if (s1 == NULL || s2 == NULL) {
      D(puts("Bad strcmp_reverse call"));
      return -2;
   }
   s2_length = strlen(s2);
   if (s1_length < s2_length) {
      return 1;
   }
   
   return strcmp(s1 + s1_length - s2_length, s2);
}

void lowerize(char *string)
{
   if (string == NULL) {
      return;
   }
   while (*string != 0) {
      *string = tolower(*string);
      string++;
   }   
}

int chomp(char *s)
{
   register char *x;
   int ret = 0;
  
   x = s;
   while (*x != 0) {
      x++;
   }
   if (x == s) { 
      ret--;
   } else if (*(--x) == '\n') {
      *x = 0;
      ret++;
      if (x != s) {
	 if (*(--x) == '\r') {
	    *x = 0;
	    ret++;
	 }
      }
   }
   return ret;
}

char *skip_spaces(char *line)
{
   while (*line == ' ') {
      line++;
   }
   return line;
}

void trim_rspaces(char *line)
{
   char *line2;
   
   if (*line == 0) {
      return;
   }   
   line2 = line + strlen(line);
   while (line2 != line && *(--line2) == ' ');
   if (*line2 == ' ') {
      *line2 = 0;
   } else {
      line2[1] = 0;
   }
   return;
}

#define SIZE_TEMPLATE(name, type) size_t size_ ## name(type n) \
{ \
  size_t s = 1; \
  \
  if (n < 0) { \
     s++; \
     n = -n; \
  } \
  while (n > (type) 9) { \
     s++; \
     n /= (type) 10; \
  } \
  \
  return s; \
}

SIZE_TEMPLATE(char, char);
SIZE_TEMPLATE(unsigned_char, unsigned char);
SIZE_TEMPLATE(int, int);
SIZE_TEMPLATE(unsigned_int, unsigned int);
SIZE_TEMPLATE(long, long);
SIZE_TEMPLATE(unsigned_long, unsigned long);
SIZE_TEMPLATE(long_long, long long);
SIZE_TEMPLATE(unsigned_long_long, unsigned long long);

